/* Import plugin specific language pack */
tinyMCE.importPluginLanguagePack('doclink');

var TinyMCE_DocLinkPlugin = {
	getInfo : function() {
		return {
			longname : 'JCE DocLink',
			author : 'Ryan Demmer',
			authorurl : 'http://www.cellardoor.za.net',
			infourl : '',
			version : '1.1.0'
		};
	},

    getControlHTML : function(cn) {
		switch (cn) {
			case "doclink":
				return tinyMCE.getButtonHTML(cn, 'lang_doclink_desc', '{$pluginurl}/images/doclink.gif', 'mceDocLink');
		}

		return "";
	},
    execCommand : function(editor_id, element, command, user_interface, value) {
		// Handle commands
		switch (command) {
			case "mceDocLink":
				tinyMCE.openWindow({
						file : tinyMCE.getParam('site') + '/index2.php?option=com_jce&no_html=1&task=plugin&plugin=doclink&file=manager.php',
						width : 750 + tinyMCE.getLang('lang_doclink_delta_width', 0),
						height : 550 + tinyMCE.getLang('lang_doclink_delta_height', 0)
					}, {
						editor_id : editor_id,
						inline : "yes"
				});

				return true;
	   }
        return false;
    },
    
    handleNodeChange : function(editor_id, node, undo_index, undo_levels, visual_aid, any_selection) {
		if (node == null)
			return;

		do {
			if (node.nodeName == "A" && tinyMCE.getAttrib(node, 'class') == "jce_doclink" ) {
				tinyMCE.switchClass(editor_id + '_doclink', 'mceButtonSelected');
				return true;
			}
		} while ((node = node.parentNode));

		tinyMCE.switchClass(editor_id + '_doclink', 'mceButtonNormal');

		return true;
	}
};

tinyMCE.addPlugin("doclink", TinyMCE_DocLinkPlugin);
