<?php
/**
 * Show a list of files.
 * @author $Author: Ryan Demmer $
 * @version $Id: files.php 27 2006-03-06 10:25:57Z Ryan Demmer $
 * @package FileManager
 */
defined( '_VALID_MOS' ) or die( 'Restricted Access.' );

$version = "1.1.0";

require_once( $mainframe->getCfg('absolute_path') . '/mambots/editors/jce/jscripts/tiny_mce/libraries/classes/jce.class.php' );
require_once( $mainframe->getCfg('absolute_path') . '/mambots/editors/jce/jscripts/tiny_mce/libraries/classes/jce.utils.class.php' );

$jce = new JCE();
$jce->setPlugin('doclink');

require_once( $jce->getPluginPath() . '/classes/manager.class.php' );

//Setup languages
include_once( $jce->getLibPath() . '/langs/' . $jce->getLanguage() . '.php' );
include_once(  $jce->getPluginPath() . '/langs/' . $jce->getPluginLanguage() . '.php' );

//Load Plugin Parameters
$params = $jce->getPluginParams();

$include_path = ini_get('include_path');
ini_set( 'include_path', $mainframe->getCfg('absolute_path' ) );
require_once( $mainframe->getCfg('absolute_path') . "/includes/sef.php" );
ini_set( 'include_path', $include_path );

include_once( $mainframe->getCfg('absolute_path') . "/administrator/components/com_docman/docman.class.php");

//DOCMan core interaction API
$_DOCMAN = new dmMainFrame( _DM_TYPE_DOCLINK );
$_DOCMAN->loadLanguage('doclink');

require_once($_DOCMAN->getPath('classes', 'utils'));
require_once($_DOCMAN->getPath('classes', 'file'));
require_once($_DOCMAN->getPath('classes', 'model'));

$id = mosGetParam( $_REQUEST, 'gid', '');
if( $id ){
	$cid = docManager::getCatId( $id );
}else{
	$cid = mosGetParam( $_REQUEST, 'catid', 0 );
}
$cats = DOCMAN_Cats::getChildsByUserAccess( $cid );
//get items
$docs = docManager::getDocs( $cid );
//Draw the file list
function drawFiles( $rows, $manager )
{
        global $jce, $mainframe, $cid, $_DOCMAN;	
		foreach( $rows as $row )
        {              		   															
			$ext = JFile::stripExt( basename( $row['icon'] ) );			
			?>
			<div class="divList" id="<?php echo $row['id'];?>" title="<?php echo $row['name'];?>.<?php echo $ext;?>">
				<img src="<?php echo $row['icon'];?>" height="16" width="16" style="vertical-align:middle;" />
				<a href="javascript:parent.selectFile('<?php echo $row['id'];?>');" title="<?php echo $row['name'];?>"><?php echo $row['name'];?></a>
				<input type="hidden" id="<?php echo $row['id'];?>_file" value="<?php echo $row['file'];?>" />
				<input type="hidden" id="<?php echo $row['id'];?>_modified" value="<?php echo $row['modified'];?>" />
			</div>
        <?php 
		}
}
//Draw the directory list
function drawDirs( $rows, $manager )
{
	global $jce, $cl;	
	$d = 0;
    foreach( $rows as $row ) {			
        ?>
        <div class="divList" id="<?php echo $row->id;?>" title="<?php echo $row->name;?>">
			<img src="<?php echo $jce->getLibImg('folder.gif');?>" title="<?php echo $row->name ?>" alt="<?php echo $row->name;?>" height="16" width="16" style="vertical-align:middle;" />
            <a href="<?php echo $jce->getPluginFile('files.php');?>&catid=<?php echo $row->id;?>" onClick="parent.showMessage('Loading', 'load.gif', 'msg');" title="<?php echo $row->name; ?>"><?php echo $row->name; ?></a>
       </div>
       <?php
	   		$d++;
   } //foreach
}
//No result - no files found
function noFiles()
{
    global $cl;?>
    <div class="noResult">
        <?php echo $cl['no_files']; ?>
    </div>
<?php
}
?>
<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<title><?php echo $pl['file_list'];?></title>
<meta http-equiv="Content-Type" content="text/html; charset=<?php echo $cl['iso'];?>" />
<?php
	echo $jce->printLibJs('mootools_basic');
	echo $jce->printLibJs('files');
	echo $jce->printLibCss( 'files' );
?>
<script type="text/javascript">
/*<![CDATA[*/    
	function init(){
		var p = parent.document;
		parent.resetManager();
        parent.showMessage("<?php echo htmlspecialchars( $cl['select_text'] );?>", 'info.gif', 'msg');
		p.getElementById('treeDetails').innerHTML = '';
		//dirlist
		<?php $rows = DOCMAN_utils::categoryArray();?>
		var html = '';
		html += '<select class="dirWidth" name="dirPath" id="dirPath" onchange="updateDir(this)">';
        html += '<option value="/">/</option>';
        <?php foreach( $rows as $row ){
        	$sel = ( $cid == $row->id ) ? ' selected="selected"' : '';?>
            html += '<option value="<?php echo $row->parent;?>:<?php echo $row->id;?>"<?php echo $sel;?>><?php echo $row->treename;?></option>';
		<?php }?>
       	html += '</select>';
        p.getElementById('dirlistcontainer').innerHTML = html;
		<?php if( $params->get('use_tree', '1') == '1' ){?>
			//dtree
			parent.jce.tree.add( 'i0', -1, '<?php echo $cl['tree_root'];?>', 'javascript:changeDir(\'/\');');	
			<?php echo docManager::dirTree();?>
			p.getElementById('treeDetails').innerHTML = parent.jce.tree;
			setTree("<?php echo $cid;?>");	 
		<?php }else{?>
			p.getElementById('treeDetails').innerHTML = '<div class="noResult"><?php echo $cl['no_tree'];?></div>';
		<?php }?>						
		<?php if( $error ){?>
			parent.showMessage('<?php echo $error;?>', 'error.gif', 'error');
		<?php }
		if( $id ){?>
			parent.setReturnFile('<?php echo $id;?>');
		<?php }?>
	}
/*]]>*/
</script>
</head>
<body style="background-color:#FFFFFF" onLoad="init();">
<div id="dirList" onselectstart="return false" class="div-list">
        <?php if( count( $cats ) > 0 ) drawDirs( $cats, $manager ); ?>
</div>
<?php
if( count( $docs ) > 0 ){?>
	<div id="fileList" onselectstart="return false" class="div-list">
        <?php drawFiles( $docs, $manager );?>
    </div>
<?php }else{
    noFiles();
}?>
    <script type="text/javascript">
    	setSelectables();
		parent.setSortables();
    </script>
</body>
</html>
