<?php
/**
* @version $Id: manager.php 2006-07-25 09:23:43Z Ryan Demmer $
* @package JCE
* @copyright Copyright (C) 2006 Ryan Demmer. All rights reserved.
* @license http://www.gnu.org/copyleft/gpl.html GNU/GPL, see LICENSE.php
* JCE is free software. This version may have been modified pursuant
* to the GNU General Public License, and as distributed it includes or
* is derivative of works licensed under the GNU General Public License or
* other free or open source software licenses.
*/
defined( '_VALID_MOS' ) or die( 'Restricted Access.' );

$version = "1.1.0";

global $database;

require_once( $mainframe->getCfg('absolute_path') . '/mambots/editors/jce/jscripts/tiny_mce/libraries/classes/jce.class.php' );
require_once( $mainframe->getCfg('absolute_path') . '/mambots/editors/jce/jscripts/tiny_mce/libraries/classes/jce.utils.class.php' );

$jce = new JCE();
$jce->setPlugin('doclink');

require_once( $jce->getPluginPath() . '/classes/manager.class.php' );

//Setup languages
include_once( $jce->getLibPath() . '/langs/' . $jce->getLanguage() . '.php' );
include_once(  $jce->getPluginPath() . '/langs/' . $jce->getPluginLanguage() . '.php' );

//Load Plugin Parameters
$params = $jce->getPluginParams();

include_once( $mainframe->getCfg('absolute_path') . "/administrator/components/com_docman/docman.class.php");

//DOCMan core interaction API
$_DOCMAN = new dmMainFrame( _DM_TYPE_DOCLINK );
$_DOCMAN->loadLanguage('doclink');

$jce->setAjax( array( 'getDocProperties', 'docManager', 'getDocProperties' ) );
$jce->setAjax( array( 'getProperties', 'docManager', 'getProperties' ) );

$jce->processAjax();
?>
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
	<title><?php echo $pl['desc'];?> : <?php echo $version;?></title>
	<meta http-equiv="Content-Type" content="text/html; charset=<?php $cl['iso'];?>" />
	<?php 
	echo $jce->printLibJs( 'tiny_mce_utils' );
	echo $jce->printLibJs( 'mootools' );
	echo $jce->printLibJs( 'utils' );
	echo $jce->printLibJs( 'manager' );
	echo $jce->printPluginJs( 'functions' );
	echo $jce->printLibJs( 'dtree' );
	echo $jce->printLibCss( 'common', true );
	echo $jce->printPluginCss( 'manager' );
	echo $jce->printLibCss( 'dtree' );
	?>
	<script type="text/javascript">
		jce.setPlugin('doclink');
	</script>
</head>
<body lang="<?php echo $jce->getPluginLanguage(); ?>" id="doclink" onLoad="init();" style="display: none">
    <form name="uploadForm" action="<?php echo $jce->getPluginFile('files.php');?>" target="manager" enctype="multipart/form-data" method="post">
    <input type="hidden" name="itemsList" id="itemsList" />
    <input type="hidden" name="file_date" id="file_date" />
    <input type="hidden" name="file_size" id="file_size" />
    <input type="hidden" name="file_icon" id="file_icon" />
	<div class="tabs">
		<ul>
			<li id="article_tab" class="current"><span><a href="javascript:mcTabs.displayTab('article_tab','article_panel');" onMouseDown="return false;"><?php echo $pl['ins_file'];?></a></span></li>
		</ul>
	</div>
	<div class="panel_wrapper">
    	<div id="article_panel" class="panel current">
    		<fieldset>
			<legend><?php echo $pl['ins_file'];?></legend>
    		<table class="properties" border="0">
				<tr>
					<td class="column1"><label id="srclabel" for="src"><?php echo $cl['url'];?></label></td>
					<td colspan="3">
					<table border="0" cellspacing="0" cellpadding="0">
						<tr>
						<td><input name="href" type="text" id="href" value="" class="input" /></td>
						</tr>
			    	</table>
					</td>
		    	</tr>
			    <tr>
					<td><label id="targetlistlabel" for="targetlist"><?php echo $cl['target'];?></label></td>
					<td><select id="targetlist" name="targetlist">
								<option value="_self"><?php echo $cl['self'];?></option>
								<option value="_blank"><?php echo $cl['blank'];?></option>
								<option value="_parent"><?php echo $cl['parent'];?></option>
								<option value="_top"><?php echo $cl['top'];?></option>								
						</select>
					</td>
				</tr>
			    <tr>
				    <td class="column1"><label id="titlelabel" for="title"><?php echo $cl['title'];?></label></td>
				    <td colspan="3"><input id="title" name="title" type="text" value="" class="input" /></td>
			    </tr>
			</table>
			<table>
			    <tr>
				    <td><input name="icon" type="checkbox" class="radio" id="icon" style="vertical-align:middle;" value="icon" /><label id="iconlabel" for="icon"><?php echo $pl['icon'];?></label></td>
				    <td><input name="date" type="checkbox" class="radio" id="date" style="vertical-align:middle;" value="date" /><label id="datelabel" for="date"><?php echo $pl['date'];?></label></td>
				    <td><input name="size" type="checkbox" class="radio" id="size" style="vertical-align:middle;" value="size" /><label id="sizelabel" for="size"><?php echo $pl['size'];?></label></td>
			    </tr>
		    </table>
			</fieldset>
    	</div>
	</div>
	<fieldset>
	<legend><?php echo $cl['browse'];?></legend>
   <table class="properties" cellpadding="0" cellspacing="0">
		<tr>
			<td colspan="5" style="vertical-align:top">
				<div id="msgIcon">
        			<img id="imgMsgContainer" src="<?php echo  $jce->getLibImg('spacer.gif');?>" width="16" height="16" border="0" alt="Message" title="Message" />
   				 </div>
    			<div id="msgDiv">
        			<span id="msgContainer" style="vertical-align:top;"></span>
    			</div>
			</td>
		</tr>
		<tr>
			<td colspan="5" style="vertical-align:top">
				 <div id="dirListBlock">
        			<label for="dirlistcontainer" style="vertical-align:middle;"><?php echo $cl['dir'];?></label>&nbsp;<div id="dirlistcontainer" style="vertical-align:middle;"></div>
    			</div>
    			<div id="dirImg" style="display: inline;"><a href="javascript:void(0)" onClick="goUpDir();" title="<?php echo $cl['dir_up'];?>" class="toolbar"><img src="<?php echo $jce->getLibImg('dir_up.gif');?>" width="20" height="20" border="0" alt="<?php echo $cl['dir_up'];?>" /></a></div>
				<div id="hlpIcon" style="display: inline;"><a href="javascript:void(0)" onClick="openHelp('mediamanager');" class="toolbar"><img src="<?php echo  $jce->getLibImg('help.gif');?>" border="0" alt="<?php echo $cl['help'];?>" width="20" height="20" title="<?php echo $cl['help'];?>" /></a></div>
			</td>
		</tr>
		<tr>
			<td style="vertical-align:top"><div id="spacerDiv"></div></td>
			<td style="vertical-align:top"><?php echo $jce->sortType();?></td>
			<td style="vertical-align:top"><?php echo $jce->sortName();?></td>
			<td colspan="2" style="vertical-align:top"><?php echo $jce->searchDiv();?></td>
		</tr>
		<tr>
			<td style="vertical-align:top">
				<div id="treeBlock">
					<div id="treeTitle">
						<?php echo $cl['folders'];?>
					</div>
					<div id="treeDetails"></div>
				</div>
			</td>
    		<td colspan="2" style="vertical-align:top"><div id="fileContainer"></div></td>
    		<td style="vertical-align:top">
				<div id="infoBlock">
					<div id="infoTitle">
						<?php echo $cl['details'];?>
					</div>
					<div id="fileDetails"></div>
				</div>
			</td>
		</tr>
	</table>
    </fieldset>
	<div class="mceActionPanel">
		<div style="float: right">
    		<input type="button" class="button "id="refresh" name="refresh" value="<?php echo $cl['refresh'];?>" onClick="refreshAction();" />
			<input type="button" id="insert" name="insert" value="{$lang_insert}" onClick="insertAction();" />
			<input type="button" id="cancel" name="cancel" value="<?php echo $cl['cancel'];?>" onClick="tinyMCEPopup.close();" />
		</div>
	</div>
    </form>
</body> 
</html> 
